diff -crBPN --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=advanced-cache.php --exclude=wp-cache-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.5.pl /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/SimplePie/Exception.php /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/SimplePie/Exception.php
*** /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/SimplePie/Exception.php	1969-12-31 17:00:00.000000000 -0700
--- /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/SimplePie/Exception.php	2012-12-17 16:18:41.000000000 -0600
***************
*** 0 ****
--- 1,52 ----
+ <?php
+ /**
+  * SimplePie
+  *
+  * A PHP-Based RSS and Atom Feed Framework.
+  * Takes the hard work out of managing a complete RSS/Atom solution.
+  *
+  * Copyright (c) 2004-2012, Ryan Parman, Geoffrey Sneddon, Ryan McCue, and contributors
+  * All rights reserved.
+  *
+  * Redistribution and use in source and binary forms, with or without modification, are
+  * permitted provided that the following conditions are met:
+  *
+  * 	* Redistributions of source code must retain the above copyright notice, this list of
+  * 	  conditions and the following disclaimer.
+  *
+  * 	* Redistributions in binary form must reproduce the above copyright notice, this list
+  * 	  of conditions and the following disclaimer in the documentation and/or other materials
+  * 	  provided with the distribution.
+  *
+  * 	* Neither the name of the SimplePie Team nor the names of its contributors may be used
+  * 	  to endorse or promote products derived from this software without specific prior
+  * 	  written permission.
+  *
+  * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS
+  * OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
+  * AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDERS
+  * AND CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+  * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
+  * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+  * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+  * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+  * POSSIBILITY OF SUCH DAMAGE.
+  *
+  * @package SimplePie
+  * @version 1.4-dev
+  * @copyright 2004-2012 Ryan Parman, Geoffrey Sneddon, Ryan McCue
+  * @author Ryan Parman
+  * @author Geoffrey Sneddon
+  * @author Ryan McCue
+  * @link http://simplepie.org/ SimplePie
+  * @license http://www.opensource.org/licenses/bsd-license.php BSD License
+  */
+ 
+ /**
+  * General SimplePie exception class
+  *
+  * @package SimplePie
+  */
+ class SimplePie_Exception extends Exception
+ {
+ }
\ No newline at end of file
diff -crBPN --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=advanced-cache.php --exclude=wp-cache-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.5.pl /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/SimplePie/File.php /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/SimplePie/File.php
*** /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/SimplePie/File.php	1969-12-31 17:00:00.000000000 -0700
--- /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/SimplePie/File.php	2012-12-17 16:18:41.000000000 -0600
***************
*** 0 ****
--- 1,292 ----
+ <?php
+ /**
+  * SimplePie
+  *
+  * A PHP-Based RSS and Atom Feed Framework.
+  * Takes the hard work out of managing a complete RSS/Atom solution.
+  *
+  * Copyright (c) 2004-2012, Ryan Parman, Geoffrey Sneddon, Ryan McCue, and contributors
+  * All rights reserved.
+  *
+  * Redistribution and use in source and binary forms, with or without modification, are
+  * permitted provided that the following conditions are met:
+  *
+  * 	* Redistributions of source code must retain the above copyright notice, this list of
+  * 	  conditions and the following disclaimer.
+  *
+  * 	* Redistributions in binary form must reproduce the above copyright notice, this list
+  * 	  of conditions and the following disclaimer in the documentation and/or other materials
+  * 	  provided with the distribution.
+  *
+  * 	* Neither the name of the SimplePie Team nor the names of its contributors may be used
+  * 	  to endorse or promote products derived from this software without specific prior
+  * 	  written permission.
+  *
+  * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS
+  * OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
+  * AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDERS
+  * AND CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+  * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
+  * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+  * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+  * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+  * POSSIBILITY OF SUCH DAMAGE.
+  *
+  * @package SimplePie
+  * @version 1.3.1
+  * @copyright 2004-2012 Ryan Parman, Geoffrey Sneddon, Ryan McCue
+  * @author Ryan Parman
+  * @author Geoffrey Sneddon
+  * @author Ryan McCue
+  * @link http://simplepie.org/ SimplePie
+  * @license http://www.opensource.org/licenses/bsd-license.php BSD License
+  */
+ 
+ /**
+  * Used for fetching remote files and reading local files
+  *
+  * Supports HTTP 1.0 via cURL or fsockopen, with spotty HTTP 1.1 support
+  *
+  * This class can be overloaded with {@see SimplePie::set_file_class()}
+  *
+  * @package SimplePie
+  * @subpackage HTTP
+  * @todo Move to properly supporting RFC2616 (HTTP/1.1)
+  */
+ class SimplePie_File
+ {
+ 	var $url;
+ 	var $useragent;
+ 	var $success = true;
+ 	var $headers = array();
+ 	var $body;
+ 	var $status_code;
+ 	var $redirects = 0;
+ 	var $error;
+ 	var $method = SIMPLEPIE_FILE_SOURCE_NONE;
+ 
+ 	public function __construct($url, $timeout = 10, $redirects = 5, $headers = null, $useragent = null, $force_fsockopen = false)
+ 	{
+ 		if (class_exists('idna_convert'))
+ 		{
+ 			$idn = new idna_convert();
+ 			$parsed = SimplePie_Misc::parse_url($url);
+ 			$url = SimplePie_Misc::compress_parse_url($parsed['scheme'], $idn->encode($parsed['authority']), $parsed['path'], $parsed['query'], $parsed['fragment']);
+ 		}
+ 		$this->url = $url;
+ 		$this->useragent = $useragent;
+ 		if (preg_match('/^http(s)?:\/\//i', $url))
+ 		{
+ 			if ($useragent === null)
+ 			{
+ 				$useragent = ini_get('user_agent');
+ 				$this->useragent = $useragent;
+ 			}
+ 			if (!is_array($headers))
+ 			{
+ 				$headers = array();
+ 			}
+ 			if (!$force_fsockopen && function_exists('curl_exec'))
+ 			{
+ 				$this->method = SIMPLEPIE_FILE_SOURCE_REMOTE | SIMPLEPIE_FILE_SOURCE_CURL;
+ 				$fp = curl_init();
+ 				$headers2 = array();
+ 				foreach ($headers as $key => $value)
+ 				{
+ 					$headers2[] = "$key: $value";
+ 				}
+ 				if (version_compare(SimplePie_Misc::get_curl_version(), '7.10.5', '>='))
+ 				{
+ 					curl_setopt($fp, CURLOPT_ENCODING, '');
+ 				}
+ 				curl_setopt($fp, CURLOPT_URL, $url);
+ 				curl_setopt($fp, CURLOPT_HEADER, 1);
+ 				curl_setopt($fp, CURLOPT_RETURNTRANSFER, 1);
+ 				curl_setopt($fp, CURLOPT_TIMEOUT, $timeout);
+ 				curl_setopt($fp, CURLOPT_CONNECTTIMEOUT, $timeout);
+ 				curl_setopt($fp, CURLOPT_REFERER, $url);
+ 				curl_setopt($fp, CURLOPT_USERAGENT, $useragent);
+ 				curl_setopt($fp, CURLOPT_HTTPHEADER, $headers2);
+ 				if (!ini_get('open_basedir') && !ini_get('safe_mode') && version_compare(SimplePie_Misc::get_curl_version(), '7.15.2', '>='))
+ 				{
+ 					curl_setopt($fp, CURLOPT_FOLLOWLOCATION, 1);
+ 					curl_setopt($fp, CURLOPT_MAXREDIRS, $redirects);
+ 				}
+ 
+ 				$this->headers = curl_exec($fp);
+ 				if (curl_errno($fp) === 23 || curl_errno($fp) === 61)
+ 				{
+ 					curl_setopt($fp, CURLOPT_ENCODING, 'none');
+ 					$this->headers = curl_exec($fp);
+ 				}
+ 				if (curl_errno($fp))
+ 				{
+ 					$this->error = 'cURL error ' . curl_errno($fp) . ': ' . curl_error($fp);
+ 					$this->success = false;
+ 				}
+ 				else
+ 				{
+ 					$info = curl_getinfo($fp);
+ 					curl_close($fp);
+ 					$this->headers = explode("\r\n\r\n", $this->headers, $info['redirect_count'] + 1);
+ 					$this->headers = array_pop($this->headers);
+ 					$parser = new SimplePie_HTTP_Parser($this->headers);
+ 					if ($parser->parse())
+ 					{
+ 						$this->headers = $parser->headers;
+ 						$this->body = $parser->body;
+ 						$this->status_code = $parser->status_code;
+ 						if ((in_array($this->status_code, array(300, 301, 302, 303, 307)) || $this->status_code > 307 && $this->status_code < 400) && isset($this->headers['location']) && $this->redirects < $redirects)
+ 						{
+ 							$this->redirects++;
+ 							$location = SimplePie_Misc::absolutize_url($this->headers['location'], $url);
+ 							return $this->__construct($location, $timeout, $redirects, $headers, $useragent, $force_fsockopen);
+ 						}
+ 					}
+ 				}
+ 			}
+ 			else
+ 			{
+ 				$this->method = SIMPLEPIE_FILE_SOURCE_REMOTE | SIMPLEPIE_FILE_SOURCE_FSOCKOPEN;
+ 				$url_parts = parse_url($url);
+ 				$socket_host = $url_parts['host'];
+ 				if (isset($url_parts['scheme']) && strtolower($url_parts['scheme']) === 'https')
+ 				{
+ 					$socket_host = "ssl://$url_parts[host]";
+ 					$url_parts['port'] = 443;
+ 				}
+ 				if (!isset($url_parts['port']))
+ 				{
+ 					$url_parts['port'] = 80;
+ 				}
+ 				$fp = @fsockopen($socket_host, $url_parts['port'], $errno, $errstr, $timeout);
+ 				if (!$fp)
+ 				{
+ 					$this->error = 'fsockopen error: ' . $errstr;
+ 					$this->success = false;
+ 				}
+ 				else
+ 				{
+ 					stream_set_timeout($fp, $timeout);
+ 					if (isset($url_parts['path']))
+ 					{
+ 						if (isset($url_parts['query']))
+ 						{
+ 							$get = "$url_parts[path]?$url_parts[query]";
+ 						}
+ 						else
+ 						{
+ 							$get = $url_parts['path'];
+ 						}
+ 					}
+ 					else
+ 					{
+ 						$get = '/';
+ 					}
+ 					$out = "GET $get HTTP/1.1\r\n";
+ 					$out .= "Host: $url_parts[host]\r\n";
+ 					$out .= "User-Agent: $useragent\r\n";
+ 					if (extension_loaded('zlib'))
+ 					{
+ 						$out .= "Accept-Encoding: x-gzip,gzip,deflate\r\n";
+ 					}
+ 
+ 					if (isset($url_parts['user']) && isset($url_parts['pass']))
+ 					{
+ 						$out .= "Authorization: Basic " . base64_encode("$url_parts[user]:$url_parts[pass]") . "\r\n";
+ 					}
+ 					foreach ($headers as $key => $value)
+ 					{
+ 						$out .= "$key: $value\r\n";
+ 					}
+ 					$out .= "Connection: Close\r\n\r\n";
+ 					fwrite($fp, $out);
+ 
+ 					$info = stream_get_meta_data($fp);
+ 
+ 					$this->headers = '';
+ 					while (!$info['eof'] && !$info['timed_out'])
+ 					{
+ 						$this->headers .= fread($fp, 1160);
+ 						$info = stream_get_meta_data($fp);
+ 					}
+ 					if (!$info['timed_out'])
+ 					{
+ 						$parser = new SimplePie_HTTP_Parser($this->headers);
+ 						if ($parser->parse())
+ 						{
+ 							$this->headers = $parser->headers;
+ 							$this->body = $parser->body;
+ 							$this->status_code = $parser->status_code;
+ 							if ((in_array($this->status_code, array(300, 301, 302, 303, 307)) || $this->status_code > 307 && $this->status_code < 400) && isset($this->headers['location']) && $this->redirects < $redirects)
+ 							{
+ 								$this->redirects++;
+ 								$location = SimplePie_Misc::absolutize_url($this->headers['location'], $url);
+ 								return $this->__construct($location, $timeout, $redirects, $headers, $useragent, $force_fsockopen);
+ 							}
+ 							if (isset($this->headers['content-encoding']))
+ 							{
+ 								// Hey, we act dumb elsewhere, so let's do that here too
+ 								switch (strtolower(trim($this->headers['content-encoding'], "\x09\x0A\x0D\x20")))
+ 								{
+ 									case 'gzip':
+ 									case 'x-gzip':
+ 										$decoder = new SimplePie_gzdecode($this->body);
+ 										if (!$decoder->parse())
+ 										{
+ 											$this->error = 'Unable to decode HTTP "gzip" stream';
+ 											$this->success = false;
+ 										}
+ 										else
+ 										{
+ 											$this->body = $decoder->data;
+ 										}
+ 										break;
+ 
+ 									case 'deflate':
+ 										if (($decompressed = gzinflate($this->body)) !== false)
+ 										{
+ 											$this->body = $decompressed;
+ 										}
+ 										else if (($decompressed = gzuncompress($this->body)) !== false)
+ 										{
+ 											$this->body = $decompressed;
+ 										}
+ 										else if (function_exists('gzdecode') && ($decompressed = gzdecode($this->body)) !== false)
+ 										{
+ 											$this->body = $decompressed;
+ 										}
+ 										else
+ 										{
+ 											$this->error = 'Unable to decode HTTP "deflate" stream';
+ 											$this->success = false;
+ 										}
+ 										break;
+ 
+ 									default:
+ 										$this->error = 'Unknown content coding';
+ 										$this->success = false;
+ 								}
+ 							}
+ 						}
+ 					}
+ 					else
+ 					{
+ 						$this->error = 'fsocket timed out';
+ 						$this->success = false;
+ 					}
+ 					fclose($fp);
+ 				}
+ 			}
+ 		}
+ 		else
+ 		{
+ 			$this->method = SIMPLEPIE_FILE_SOURCE_LOCAL | SIMPLEPIE_FILE_SOURCE_FILE_GET_CONTENTS;
+ 			if (!$this->body = file_get_contents($url))
+ 			{
+ 				$this->error = 'file_get_contents could not read the file';
+ 				$this->success = false;
+ 			}
+ 		}
+ 	}
+ }
diff -crBPN --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=advanced-cache.php --exclude=wp-cache-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.5.pl /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/SimplePie/gzdecode.php /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/SimplePie/gzdecode.php
*** /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/SimplePie/gzdecode.php	1969-12-31 17:00:00.000000000 -0700
--- /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/SimplePie/gzdecode.php	2012-12-17 16:18:41.000000000 -0600
***************
*** 0 ****
--- 1,371 ----
+ <?php
+ /**
+  * SimplePie
+  *
+  * A PHP-Based RSS and Atom Feed Framework.
+  * Takes the hard work out of managing a complete RSS/Atom solution.
+  *
+  * Copyright (c) 2004-2012, Ryan Parman, Geoffrey Sneddon, Ryan McCue, and contributors
+  * All rights reserved.
+  *
+  * Redistribution and use in source and binary forms, with or without modification, are
+  * permitted provided that the following conditions are met:
+  *
+  * 	* Redistributions of source code must retain the above copyright notice, this list of
+  * 	  conditions and the following disclaimer.
+  *
+  * 	* Redistributions in binary form must reproduce the above copyright notice, this list
+  * 	  of conditions and the following disclaimer in the documentation and/or other materials
+  * 	  provided with the distribution.
+  *
+  * 	* Neither the name of the SimplePie Team nor the names of its contributors may be used
+  * 	  to endorse or promote products derived from this software without specific prior
+  * 	  written permission.
+  *
+  * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS
+  * OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
+  * AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDERS
+  * AND CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+  * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
+  * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+  * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+  * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+  * POSSIBILITY OF SUCH DAMAGE.
+  *
+  * @package SimplePie
+  * @version 1.3.1
+  * @copyright 2004-2012 Ryan Parman, Geoffrey Sneddon, Ryan McCue
+  * @author Ryan Parman
+  * @author Geoffrey Sneddon
+  * @author Ryan McCue
+  * @link http://simplepie.org/ SimplePie
+  * @license http://www.opensource.org/licenses/bsd-license.php BSD License
+  */
+ 
+ 
+ /**
+  * Decode 'gzip' encoded HTTP data
+  *
+  * @package SimplePie
+  * @subpackage HTTP
+  * @link http://www.gzip.org/format.txt
+  */
+ class SimplePie_gzdecode
+ {
+ 	/**
+ 	 * Compressed data
+ 	 *
+ 	 * @access private
+ 	 * @var string
+ 	 * @see gzdecode::$data
+ 	 */
+ 	var $compressed_data;
+ 
+ 	/**
+ 	 * Size of compressed data
+ 	 *
+ 	 * @access private
+ 	 * @var int
+ 	 */
+ 	var $compressed_size;
+ 
+ 	/**
+ 	 * Minimum size of a valid gzip string
+ 	 *
+ 	 * @access private
+ 	 * @var int
+ 	 */
+ 	var $min_compressed_size = 18;
+ 
+ 	/**
+ 	 * Current position of pointer
+ 	 *
+ 	 * @access private
+ 	 * @var int
+ 	 */
+ 	var $position = 0;
+ 
+ 	/**
+ 	 * Flags (FLG)
+ 	 *
+ 	 * @access private
+ 	 * @var int
+ 	 */
+ 	var $flags;
+ 
+ 	/**
+ 	 * Uncompressed data
+ 	 *
+ 	 * @access public
+ 	 * @see gzdecode::$compressed_data
+ 	 * @var string
+ 	 */
+ 	var $data;
+ 
+ 	/**
+ 	 * Modified time
+ 	 *
+ 	 * @access public
+ 	 * @var int
+ 	 */
+ 	var $MTIME;
+ 
+ 	/**
+ 	 * Extra Flags
+ 	 *
+ 	 * @access public
+ 	 * @var int
+ 	 */
+ 	var $XFL;
+ 
+ 	/**
+ 	 * Operating System
+ 	 *
+ 	 * @access public
+ 	 * @var int
+ 	 */
+ 	var $OS;
+ 
+ 	/**
+ 	 * Subfield ID 1
+ 	 *
+ 	 * @access public
+ 	 * @see gzdecode::$extra_field
+ 	 * @see gzdecode::$SI2
+ 	 * @var string
+ 	 */
+ 	var $SI1;
+ 
+ 	/**
+ 	 * Subfield ID 2
+ 	 *
+ 	 * @access public
+ 	 * @see gzdecode::$extra_field
+ 	 * @see gzdecode::$SI1
+ 	 * @var string
+ 	 */
+ 	var $SI2;
+ 
+ 	/**
+ 	 * Extra field content
+ 	 *
+ 	 * @access public
+ 	 * @see gzdecode::$SI1
+ 	 * @see gzdecode::$SI2
+ 	 * @var string
+ 	 */
+ 	var $extra_field;
+ 
+ 	/**
+ 	 * Original filename
+ 	 *
+ 	 * @access public
+ 	 * @var string
+ 	 */
+ 	var $filename;
+ 
+ 	/**
+ 	 * Human readable comment
+ 	 *
+ 	 * @access public
+ 	 * @var string
+ 	 */
+ 	var $comment;
+ 
+ 	/**
+ 	 * Don't allow anything to be set
+ 	 *
+ 	 * @param string $name
+ 	 * @param mixed $value
+ 	 */
+ 	public function __set($name, $value)
+ 	{
+ 		trigger_error("Cannot write property $name", E_USER_ERROR);
+ 	}
+ 
+ 	/**
+ 	 * Set the compressed string and related properties
+ 	 *
+ 	 * @param string $data
+ 	 */
+ 	public function __construct($data)
+ 	{
+ 		$this->compressed_data = $data;
+ 		$this->compressed_size = strlen($data);
+ 	}
+ 
+ 	/**
+ 	 * Decode the GZIP stream
+ 	 *
+ 	 * @return bool Successfulness
+ 	 */
+ 	public function parse()
+ 	{
+ 		if ($this->compressed_size >= $this->min_compressed_size)
+ 		{
+ 			// Check ID1, ID2, and CM
+ 			if (substr($this->compressed_data, 0, 3) !== "\x1F\x8B\x08")
+ 			{
+ 				return false;
+ 			}
+ 
+ 			// Get the FLG (FLaGs)
+ 			$this->flags = ord($this->compressed_data[3]);
+ 
+ 			// FLG bits above (1 << 4) are reserved
+ 			if ($this->flags > 0x1F)
+ 			{
+ 				return false;
+ 			}
+ 
+ 			// Advance the pointer after the above
+ 			$this->position += 4;
+ 
+ 			// MTIME
+ 			$mtime = substr($this->compressed_data, $this->position, 4);
+ 			// Reverse the string if we're on a big-endian arch because l is the only signed long and is machine endianness
+ 			if (current(unpack('S', "\x00\x01")) === 1)
+ 			{
+ 				$mtime = strrev($mtime);
+ 			}
+ 			$this->MTIME = current(unpack('l', $mtime));
+ 			$this->position += 4;
+ 
+ 			// Get the XFL (eXtra FLags)
+ 			$this->XFL = ord($this->compressed_data[$this->position++]);
+ 
+ 			// Get the OS (Operating System)
+ 			$this->OS = ord($this->compressed_data[$this->position++]);
+ 
+ 			// Parse the FEXTRA
+ 			if ($this->flags & 4)
+ 			{
+ 				// Read subfield IDs
+ 				$this->SI1 = $this->compressed_data[$this->position++];
+ 				$this->SI2 = $this->compressed_data[$this->position++];
+ 
+ 				// SI2 set to zero is reserved for future use
+ 				if ($this->SI2 === "\x00")
+ 				{
+ 					return false;
+ 				}
+ 
+ 				// Get the length of the extra field
+ 				$len = current(unpack('v', substr($this->compressed_data, $this->position, 2)));
+ 				$this->position += 2;
+ 
+ 				// Check the length of the string is still valid
+ 				$this->min_compressed_size += $len + 4;
+ 				if ($this->compressed_size >= $this->min_compressed_size)
+ 				{
+ 					// Set the extra field to the given data
+ 					$this->extra_field = substr($this->compressed_data, $this->position, $len);
+ 					$this->position += $len;
+ 				}
+ 				else
+ 				{
+ 					return false;
+ 				}
+ 			}
+ 
+ 			// Parse the FNAME
+ 			if ($this->flags & 8)
+ 			{
+ 				// Get the length of the filename
+ 				$len = strcspn($this->compressed_data, "\x00", $this->position);
+ 
+ 				// Check the length of the string is still valid
+ 				$this->min_compressed_size += $len + 1;
+ 				if ($this->compressed_size >= $this->min_compressed_size)
+ 				{
+ 					// Set the original filename to the given string
+ 					$this->filename = substr($this->compressed_data, $this->position, $len);
+ 					$this->position += $len + 1;
+ 				}
+ 				else
+ 				{
+ 					return false;
+ 				}
+ 			}
+ 
+ 			// Parse the FCOMMENT
+ 			if ($this->flags & 16)
+ 			{
+ 				// Get the length of the comment
+ 				$len = strcspn($this->compressed_data, "\x00", $this->position);
+ 
+ 				// Check the length of the string is still valid
+ 				$this->min_compressed_size += $len + 1;
+ 				if ($this->compressed_size >= $this->min_compressed_size)
+ 				{
+ 					// Set the original comment to the given string
+ 					$this->comment = substr($this->compressed_data, $this->position, $len);
+ 					$this->position += $len + 1;
+ 				}
+ 				else
+ 				{
+ 					return false;
+ 				}
+ 			}
+ 
+ 			// Parse the FHCRC
+ 			if ($this->flags & 2)
+ 			{
+ 				// Check the length of the string is still valid
+ 				$this->min_compressed_size += $len + 2;
+ 				if ($this->compressed_size >= $this->min_compressed_size)
+ 				{
+ 					// Read the CRC
+ 					$crc = current(unpack('v', substr($this->compressed_data, $this->position, 2)));
+ 
+ 					// Check the CRC matches
+ 					if ((crc32(substr($this->compressed_data, 0, $this->position)) & 0xFFFF) === $crc)
+ 					{
+ 						$this->position += 2;
+ 					}
+ 					else
+ 					{
+ 						return false;
+ 					}
+ 				}
+ 				else
+ 				{
+ 					return false;
+ 				}
+ 			}
+ 
+ 			// Decompress the actual data
+ 			if (($this->data = gzinflate(substr($this->compressed_data, $this->position, -8))) === false)
+ 			{
+ 				return false;
+ 			}
+ 			else
+ 			{
+ 				$this->position = $this->compressed_size - 8;
+ 			}
+ 
+ 			// Check CRC of data
+ 			$crc = current(unpack('V', substr($this->compressed_data, $this->position, 4)));
+ 			$this->position += 4;
+ 			/*if (extension_loaded('hash') && sprintf('%u', current(unpack('V', hash('crc32b', $this->data)))) !== sprintf('%u', $crc))
+ 			{
+ 				return false;
+ 			}*/
+ 
+ 			// Check ISIZE of data
+ 			$isize = current(unpack('V', substr($this->compressed_data, $this->position, 4)));
+ 			$this->position += 4;
+ 			if (sprintf('%u', strlen($this->data) & 0xFFFFFFFF) !== sprintf('%u', $isize))
+ 			{
+ 				return false;
+ 			}
+ 
+ 			// Wow, against all odds, we've actually got a valid gzip string
+ 			return true;
+ 		}
+ 		else
+ 		{
+ 			return false;
+ 		}
+ 	}
+ }
